// Tets_Asm.cpp : Defines the entry point for the console application.
//

// TestAsm.cpp : Defines the entry point for the console application.
//

#include "stdafx.h"
#include <stdlib.h>
#include <math.h>
#include <time.h>

#include "windows.h"

#define MAX 10000000

inline int roundf(float x) 
{
	int n = 0;
	__asm
	{
		fld     x
		fistp   n
	}
	return n;
}

inline int roundf2(float x) 
{
	int n = 0;
	n = (int)(x);
	return n;
}

inline int roundf3(float x) 
{
	int n = 0;
	n = (int)(x+0.5);
	return n;
}

int main(int argc, char* argv[])
{
	unsigned long dwStartTime = 0;
	unsigned long dwEndTime = 0;

	int i=0;

	int *nAr = new int[MAX];
	float *fAr = new float[MAX];
	long double *dAr = new long double[MAX];

	srand((unsigned)time(NULL));

	for(i=0; i<MAX; i++)
	{
		fAr[i] = ((float)((999+rand())%1000))/100.0f;
		// printf("  %2.2f\n",  f[i]);
	}

	dwStartTime = GetTickCount();
	for(i=0; i<MAX; i++)
	{
		nAr[i] = roundf(fAr[i]);
	}
	dwEndTime = GetTickCount();
	printf("Res asm: %d msec\n", dwEndTime-dwStartTime);

	dwStartTime = GetTickCount();
	for(i=0; i<MAX; i++)
	{
		nAr[i] = roundf2(fAr[i]);
	}
	dwEndTime = GetTickCount();
	printf("Res (int): %d msec\n", dwEndTime-dwStartTime);

	dwStartTime = GetTickCount();
	for(i=0; i<MAX; i++)
	{
		nAr[i] = roundf3(fAr[i]);
	}
	dwEndTime = GetTickCount();
	printf("Res (int)+0.5: %d msec\n", dwEndTime-dwStartTime);

	dwStartTime = GetTickCount();
	for(i=0; i<MAX; i++)
	{
		dAr[i] = ceil(fAr[i]);
	}
	dwEndTime = GetTickCount();
	printf("Res ceil: %d msec\n", dwEndTime-dwStartTime);

	delete [] nAr;
	delete [] fAr;
	delete [] dAr;
	return 0;
}


